// Cuboid_search_v01.cpp
//
//#include "stdafx.h"
#include "Cuboid_search_v01.h"
#include "math.h"
#include "time.h"
#include <ctime>
#include <process.h>
//#include <stdexcept>
#include <iostream>
#include <fstream>
using namespace std;

// record structure for each prime in the list
struct primes_item 
{
 short prime;
 unsigned int p_offset; 
};
// buffer for reading primes list
primes_item * Primes_list_ptr;
char * Primes_list_buffer_ptr;
unsigned int Primes_list_length;
unsigned int Primes_list_items;

// buffer for reading pq bit-tables all at once
char * pq_buffer_ptr;
unsigned int pq_bit_tables_length;

// File stream for writing pq bit-tables
ofstream of_pq;
// File stream for reading p_q bit-tables
ifstream if_pq;
// File stream for reading primes list with bitmap offsets
ifstream if_primes;
// File stream for writing the cuboid search report
ofstream of_report;
// Constants used in assembly division and multiplication
unsigned int Const_0=0, Const_2=2, Const_4=4, Const_6=6, 
             Const_8=8, Const_10=10, Const_14=14;
bool Search_is_running=false; // flag variable signalling that the srach is on
bool Should_stop_searching=false; // flag variable to stop searching cuboids 
bool Binaries_are_loaded=false; // flag variable indicating that primes list and bit-tables are loaded

// variables to transmit loop variables outside the DLL and vice versa
unsigned int p_global;
unsigned int q_global;
unsigned int r_max=1; // indicator of the naximal prime used for seiving
char  string_buffer[250]; // buffer for sprintf_s string formatting

unsigned int __stdcall Load_Cuboid_Binaries()
{
 unsigned int Primes_list_length_local;
 if (Binaries_are_loaded)
 {
  return(0); 
 };
 if_primes.open("Cuboid_primes.bin",ios::in | ios::binary); 
 if_primes.seekg(0,if_primes.end);
 Primes_list_length=if_primes.tellg();
 Primes_list_items=unsigned int(ceil((Primes_list_length-0.1)/6)); 
 if_primes.seekg(0,if_primes.beg);
 Primes_list_buffer_ptr=new char[Primes_list_length];
 if_primes.read(Primes_list_buffer_ptr,Primes_list_length);
 if_primes.close();
 Primes_list_ptr=reinterpret_cast<primes_item*>(Primes_list_buffer_ptr);
 
 if_pq.open("Cuboid_pq_bit_tables.bin",ios::in | ios::binary);
 if_pq.seekg(0,if_pq.end);
 pq_bit_tables_length=if_pq.tellg();
 if_pq.seekg(0,if_pq.beg);
 pq_buffer_ptr=new char[pq_bit_tables_length];
 if_pq.read(pq_buffer_ptr,pq_bit_tables_length);
 if_pq.close();
 Binaries_are_loaded=true;
 Primes_list_length_local=Primes_list_length;
 return Primes_list_length_local;
}
unsigned int __stdcall Release_Cuboid_Binaries()
{
 if (!Binaries_are_loaded)
 {
  return(6); 
 };
 if (Search_is_running)
 {
  return(1); 
 };
 delete[] Primes_list_buffer_ptr;
 delete[] pq_buffer_ptr;
 Binaries_are_loaded=false;
 return(0); 
}
// function reporting that potential perfect cuboids is found
void __stdcall Write_potential_cuboid(unsigned int p, unsigned int q)
{
 sprintf_s(string_buffer,"PC p=%u, q=%u is found.\n",p,q);
 of_report << string_buffer;
}
// the most important function performing search for potential perfect cuboids
void Look_for_cuboids_thread(void * arg)
{
 // _sleep(500);
 unsigned int ppp;  // local p
 unsigned int qqq;  // local q
 unsigned int rrr;  // local r
 unsigned int n_primes; // local primes counter
 Should_stop_searching=false;
 Search_is_running=true;
 ppp=p_global;
 qqq=q_global;
 r_max=1;
 unsigned int lower_limit_qqq;
 unsigned int upper_limit_qqq;
 of_report.open("Cuboid_search_report.txt",ios::out | ios::ate | ios::app);
 time_t t = time(0);   // get time now
 struct tm * now; 
 now=new tm;
 localtime_s(now,&t);
  of_report << (now->tm_year + 1900) << '-' 
           << (now->tm_mon + 1) << '-'
           <<  now->tm_mday << ' '
           <<  now->tm_hour << ':'
           <<  now->tm_min  << endl;
 sprintf_s(string_buffer,"Start with p=%u, q=%u",ppp,qqq);
 of_report << string_buffer << endl;
 lower_limit_qqq=unsigned int(ceil(pow(ppp/9,0.333333))); 
 upper_limit_qqq=ppp*59;
 
 while (!Should_stop_searching)
 {
  while ((!Should_stop_searching) && (lower_limit_qqq<=qqq) && (qqq<=upper_limit_qqq))
  {
   if (ppp==qqq) {qqq++; continue;};
        // do things here
   __asm{
        mov ecx,Primes_list_items
        mov n_primes,ecx
        mov edi,Primes_list_buffer_ptr
        push edi
        m_005: // entry to the cycle on primes
        pop edi
        xor ebx,ebx
        mov bx,[edi]
        mov rrr,ebx
        mov esi,[edi+2]
		add esi,pq_buffer_ptr //address to pq block in edi
        
        mov eax,qqq
		xor edx,edx
		div rrr
		push edx // qqq modulo rrr in stack
		
		mov eax,ppp
		xor edx,edx
		div rrr
		mov eax,edx // ppp modulo rrr in edx and in eax
		mul rrr
		pop ebx // qqq modulo rrr in ebx
		add eax,ebx
        adc edx,0
        div Const_8 // =8 bits in one byte
        
        mov ebx,eax // byte offset in ebx
        mov ecx,edx // bit offset in ecx
        
        mov al,1
        or cl,cl
        jz m_006
        m_007:
        shl al,1
        loop m_007 // bit mask in al
        m_006:
        
        and al,[esi+ebx] //address to unsolvability byte in esi+ebx
        jnz m_008 // unsolvability bit is on
        dec n_primes
        jz m_009 // potential cuboud is found
        add edi,6 // pass to the next prime in the prime list
        push edi
        jmp m_005 // loop to the next prime
        m_009: 
        push qqq
        push ppp
        call Write_potential_cuboid
        jmp m_010
        m_008:
		mov eax,rrr
		cmp r_max,eax
		jnc m_010
		mov r_max,eax
        m_010:
   };          
   // end do things here
   if (!Should_stop_searching)
   {
    qqq++;
   };
  }; // end of while qqq
  if (!Should_stop_searching)
  {
   if (ppp % 100 == 0) // for to reduce the output
   {
    sprintf_s(string_buffer,"p=%u, q=%u, r_max=%u,\n",ppp,qqq,r_max);
    of_report << string_buffer;
    of_report.flush();
	p_global=ppp;
	r_max=1;
   };
   ppp++;
   lower_limit_qqq=int(ceil(pow(ppp/9,0.333333)));
   upper_limit_qqq=ppp*59;
   qqq=lower_limit_qqq;
  };
 }; // end of while ppp
 p_global=ppp;
 q_global=qqq;
 t = time(0);   // get time now
 now=new tm;
 localtime_s(now,&t);
 of_report << (now->tm_year + 1900) << '-' 
           << (now->tm_mon + 1) << '-'
           <<  now->tm_mday << ' '
           <<  now->tm_hour << ':'
           <<  now->tm_min  << endl;
 sprintf_s(string_buffer,"Stop with p=%u, q=%u, r_max=%u\n",ppp,qqq,r_max);
 of_report << string_buffer;
 of_report.close();
 // _sleep(500);
 Search_is_running=false; 
 Should_stop_searching=false;
 }
unsigned int __stdcall Start_searching(unsigned int p, unsigned int q)
{
 unsigned int lower_limit_q_local;
 unsigned int upper_limit_q_local;
 if (Search_is_running)
 {
  return(1); 
 };
 if (p<152) // there are no cuboids for p<151
 {
  return(2); 
 };
 if (p>72796055) // 32 bit limit for P*59
 {
  return(3); 
 };
 lower_limit_q_local=unsigned int(ceil(pow(p/9,0.333333))); 
 upper_limit_q_local=p*59;
 if (q<lower_limit_q_local) 
 {
  return(4); 
 };
 if (q>upper_limit_q_local) 
 {
  return(5); 
 };
 if (!Binaries_are_loaded)
 {
  return(6); 
 };
 // Should_stop_searching=false;
 p_global=p;
 q_global=q;
 // Search_is_running=true;
 _beginthread(Look_for_cuboids_thread,0,(void*)12);
 return(0);
}
unsigned int __stdcall Stop_searching()
{
if (!Search_is_running)
 {
  return(1); 
 };
Should_stop_searching=true;
  return(0); 
};
unsigned int __stdcall Get_current_p()
{
 unsigned int p_local;
 p_local=p_global;
 return(p_local);
};
unsigned int __stdcall Get_current_r_max()
{
 unsigned int r_max_local;
 r_max_local=r_max;
 return(r_max_local);
};
unsigned int __stdcall Get_prime(unsigned int N)
{
 __asm{
		mov edi,Primes_list_ptr 
		mov eax,6
		mul N
		add edi,eax
		xor eax,eax
		mov ax,[edi]	
 }
}
char __stdcall Is_unsolvable(unsigned int p, unsigned int q, unsigned int i)
{
unsigned int rrr;
 __asm{
        mov eax,i
        mul Const_6
        mov edi,eax
		add edi,Primes_list_buffer_ptr 
        xor eax,eax
        mov ax,[edi]
        mov rrr,eax
        mov esi,[edi+2] 
		add esi,pq_buffer_ptr

		mov eax,q
		xor edx,edx
		div rrr
		push edx // q modulo rrr in stack
		
		mov eax,p
		xor edx,edx
		div rrr
		mov eax,edx // p modulo rrr in edx and in eax
		mul rrr
		pop ebx // q modulo rrr in ebx
		add eax,ebx
        adc edx,0
        div Const_8 // =8 bits in one byte
        
        mov ebx,eax // byte offset in ebax
        mov ecx,edx // bit offset in ecx
        
        mov al,1
        or cl,cl
        jz m_011
        m_012:
        shl al,1
        loop m_012 // bit mask in al
        m_011:
        
        and al,[esi+ebx] //address to unsolvability byte in esi+ebx
        mov eax,1
		jnz m_013 // unsolvability bit is on
		mov eax,0
        m_013:
 };
};

// Global variables for calculating the value of the polynomial Q_pq 
unsigned int rr_1;    // stored prime r value
unsigned int pp_1;  // stored p value
unsigned int pp_2;  // stored p^2 value
unsigned int pp_4;  // stored p^4 value
unsigned int pp_6;  // stored p^6 value
unsigned int pp_8;  // stored p^8 value
unsigned int pp_10; // stored p^10 value

unsigned int qq_1;  // stored q^2 value
unsigned int qq_2;  // stored q^2 value
unsigned int qq_4;  // stored q^4 value
unsigned int qq_6;  // stored q^6 value
unsigned int qq_8;  // stored q^8 value
unsigned int qq_10; // stored q^10 value

unsigned int pp_2_qq_2, pp_2_qq_6, pp_6_qq_2, pp_2_qq_10, pp_10_qq_2;
unsigned int pp_4_qq_4, pp_4_qq_8, pp_8_qq_4, pp_6_qq_6, pp_6_qq_10, pp_10_qq_6;
unsigned int pp_8_qq_8, pp_10_qq_10; 

unsigned int Coeff_0, Coeff_2, Coeff_4, Coeff_6, Coeff_8;

unsigned int tt_1;  // stored p^2 value
unsigned int tt_2;  // stored p^2 value
unsigned int tt_4;  // stored p^4 value
unsigned int tt_6;  // stored p^6 value
unsigned int tt_8;  // stored p^8 value
unsigned int tt_10; // stored p^10 value
unsigned int Q_pq;

void __stdcall Calculate_pp_values()
{
__asm{
		mov eax,pp_1
		mul pp_1
		div rr_1
		mov pp_2,edx // store p^2 mod r
		
		mov eax,edx
        mul pp_2
		div rr_1
		mov pp_4,edx // store p^4 mod r

        mov eax,edx
        mul pp_2
		div rr_1
		mov pp_6,edx // store p^6 mod r

        mov eax,edx
		mul pp_2
		div rr_1
		mov pp_8,edx // store p^8 mod r

        mov eax,edx
		mul pp_2
		div rr_1
		mov pp_10,edx // store p^10 mod r
 }
}
void __stdcall Calculate_pp_qq_and_coeff_values()
{
 __asm{
		mov eax,qq_1
		mul qq_1
		div rr_1
		mov qq_2,edx // store q^2 mod r

		mov eax,edx
        mul qq_2
		div rr_1
		mov qq_4,edx // store q^4 mod r

        mov eax,edx
        mul qq_2
		div rr_1
		mov qq_6,edx // store q^6 mod r

        mov eax,edx
		mul qq_2
		div rr_1
		mov qq_8,edx // store q^8 mod r

        mov eax,edx
		mul qq_2
		div rr_1
		mov qq_10,edx // store q^10 mod r
		
		//------------------------------

		mov eax,pp_2
        mul qq_2
		div rr_1
		mov pp_2_qq_2,edx // store p^2*q^2 mod r

		mov eax,pp_2
		mul qq_6
		div rr_1
		mov pp_2_qq_6,edx // store p^2*q^6 mod r

		mov eax,qq_2
		mul pp_6
		div rr_1
		mov pp_6_qq_2,edx // store p^6*q^2 mod r

		mov eax,pp_2
		mul qq_10
		div rr_1
		mov pp_2_qq_10,edx // store p^2*q^10 mod r

		mov eax,qq_2
		mul pp_10
		div rr_1
		mov pp_10_qq_2,edx // store p^10*q^2 mod r

		//----------------------------------------

		mov eax,pp_4
		mul qq_4
		div rr_1
		mov pp_4_qq_4,edx // store p^4*q^4 mod r

		mov eax,pp_4
		mul qq_8
		div rr_1
		mov pp_4_qq_8,edx // store p^4*q^8 mod r

		mov eax,qq_4
		mul pp_8
		div rr_1
		mov pp_8_qq_4,edx // store p^8*q^4 mod r

		//----------------------------------------

		mov eax,pp_6
		mul qq_6
		div rr_1
		mov pp_6_qq_6,edx // store p^6*q^6 mod r
		
		mov eax,pp_6
		mul qq_10
		div rr_1
		mov pp_6_qq_10,edx // store p^6*q^10 mod r
		
		mov eax,qq_6
		mul pp_10
		div rr_1
		mov pp_10_qq_6,edx // store p^10*q^6 mod r

		//----------------------------------------

		mov eax,qq_8
		mul pp_8
		div rr_1
		mov pp_8_qq_8,edx // store p^8*q^8 mod r

		mov eax,qq_10
		mul pp_10
		div rr_1
		mov pp_10_qq_10,edx // store p^10*q^10 mod r
		
		//----------------------------------------

		mov eax,rr_1 
		sub eax,pp_10_qq_10
		xor edx,edx
		div rr_1
		mov Coeff_0,edx // store Coeff_0 mod r

		//----------------------------------------

		mov eax,pp_8_qq_8
		mov Coeff_2,eax
		xor ecx,ecx // Coeff_2_hi in ecx

		mov eax,pp_6_qq_10
		mul Const_2 // multiplication by 2
		add Coeff_2,eax
		adc ecx,edx //Coeff_2_hi in ecx

		mov	eax,rr_1  
		sub eax,pp_10_qq_6
		mul Const_6 // multiplication by -6
		add Coeff_2,eax
		adc ecx,edx  //Coeff_2_hi in edx

		mov eax,Coeff_2
		mov edx,ecx
		div rr_1
		mov Coeff_2,edx // store Coeff_2 mod r

		//----------------------------------------

		mov	eax,rr_1
		sub eax,pp_2_qq_10
		mov Coeff_4,eax
		xor ecx,ecx //Coeff_4_hi in ecx
		xor edx,edx
		
		mov	eax,rr_1
		sub eax,pp_10_qq_2
		add Coeff_4,eax
		adc ecx,edx //Coeff_4_hi in ecx

		mov	eax,rr_1
		sub eax,pp_6_qq_6
		mul Const_4 // multiplication by -4
		add Coeff_4,eax
		adc ecx,edx //Coeff_4_hi in ecx

		mov	eax,rr_1
		sub eax,pp_8_qq_4
		mul Const_10 // multiplication by -10
		add Coeff_4,eax
		adc ecx,edx //Coeff_4_hi in ecx

		mov eax,pp_4_qq_8
		mul Const_14 // multiplication by 14
		add Coeff_4,eax
		adc ecx,edx //Coeff_4_hi in ecx

		mov eax,Coeff_4
		mov edx,ecx
		div rr_1
		mov Coeff_4,edx // store Coeff_4 mod r

		//----------------------------------------

		mov eax,pp_8
		mov Coeff_6,eax
		xor ecx,ecx //Coeff_6_hi in ecx
		xor edx,edx

		mov eax,qq_8
		add Coeff_6,eax
		adc ecx,edx //Coeff_6_hi in ecx

		mov eax,pp_4_qq_4
		mul Const_4 // multiplication by 4
		add Coeff_6,eax
		adc ecx,edx //Coeff_6_hi in ecx

		mov eax,pp_2_qq_6
		mul Const_10 // multiplication by 10
		add Coeff_6,eax
		adc ecx,edx //Coeff_6_hi in ecx

		mov eax,rr_1
		sub eax,pp_6_qq_2
		mul Const_14 // multiplication by 14
		add Coeff_6,eax
		adc ecx,edx //Coeff_6_hi in ecx

		mov eax,Coeff_6
		mov edx,ecx
		div rr_1
		mov Coeff_6,edx // store Coeff_6 mod r

		//----------------------------------------

		mov eax,rr_1
		sub eax,pp_2_qq_2
		mov Coeff_8,eax
		xor ecx,ecx //Coeff_8_hi in ecx
		
		mov eax,rr_1
		sub eax,pp_4
		mul Const_2 // multiplication by 4
		add Coeff_8,eax
		adc ecx,edx //Coeff_8_hi in ecx

		mov eax,qq_4
		mul Const_6 // multiplication by 4
		add Coeff_8,eax
		adc ecx,edx //Coeff_8_hi in ecx

		mov eax,Coeff_8
		mov edx,ecx
		div rr_1
		mov Coeff_8,edx // store Coeff_8 mod r
 }
}
// Calculate polynomial modulo r 
void __stdcall Calculate_Q_pq_values()
{
__asm{
		mov eax,tt_1
		mul tt_1
		div rr_1
		mov tt_2,edx // store p^2 mod r

		mov eax,edx
        mul tt_2
		div rr_1
		mov tt_4,edx // store p^4 mod r

        mov eax,edx
        mul tt_2
		div rr_1
		mov tt_6,edx // store p^6 mod r

        mov eax,edx
		mul tt_2
		div rr_1
		mov tt_8,edx // store p^8 mod r

        mov eax,edx
		mul tt_2
		div rr_1
		mov tt_10,edx // store p^10 mod r

		mov eax,Coeff_0
		mov Q_pq,eax
		xor ecx,ecx //Q_pq_hi in ecx

		mov eax,Coeff_2
		mul tt_2
		add Q_pq,eax
		adc ecx,edx //Q_pq_hi in ecx

		mov eax,Coeff_4
		mul tt_4
		add Q_pq,eax
		adc ecx,edx //Q_pq_hi in ecx

		mov eax,Coeff_6
		mul tt_6
		add Q_pq,eax
		adc ecx,edx //Q_pq_hi in ecx

		mov eax,Coeff_8
		mul tt_8
		add Q_pq,eax
		adc ecx,edx //Q_pq_hi in ecx

		mov eax,tt_10
		xor edx,edx
		add Q_pq,eax
		adc ecx,edx //Q_pq_hi in ecx

		mov eax,Q_pq
		mov edx,ecx
		div rr_1
		mov Q_pq,edx // store Q_pq mod r
 }
}

unsigned int __stdcall Calculate_Q_pq_mod_prime(unsigned int p, unsigned int q,unsigned int t, unsigned int r)
{
 rr_1=r;
 pp_1=p;
 Calculate_pp_values();
 qq_1=q;
 Calculate_pp_qq_and_coeff_values();
 tt_1=t;
 Calculate_Q_pq_values();
 __asm{
	mov eax,Q_pq
 };
}
unsigned short x=45712,zx=59;
unsigned int y=45712,zy=59;
void __stdcall ShortTest()
{
__asm{
		mov ecx,16777215
		m_001:
		mov ax,x
		mul x
		mov bx,ax
		mov ax,dx
		xor dx,dx
		div zx
		mov ax,bx
		div zx
		loop m_001
 }
}
void __stdcall IntTest()
{
__asm{
		mov ecx,16777215
		m_002:
		mov eax,y
		mul y
		div zy	
		loop m_002
 }
}
void __stdcall Open_pq_file_stream()
{
 of_pq.open("Cuboid_pq_bit_tables.bin",ios::out | ios::binary | ios::trunc);
}
void __stdcall Close_pq_file_stream()
{
 of_pq.close();
}
unsigned int __stdcall Write_pq_file_stream(unsigned int rrr)
{
 unsigned int Bit_array_size;
 char * Bit_array_ptr;
 unsigned int Bit_address;
 unsigned int Byte_offset;
 bool   Unsolvables_available;
 unsigned int nn;
  
 Bit_array_size=rrr*rrr;				// number of bits in the bit array
  __asm{
        mov eax,Bit_array_size
		xor edx,edx
        div Const_8						//remainder in dl, Const_8=8
		mov Bit_array_size,eax			
		xor eax,eax
		cmp al,dl
		adc Bit_array_size,eax			// number of bytes in the bit array
 };
 Bit_array_ptr=new char [Bit_array_size];
 __asm{
		mov ecx,Bit_array_size
		mov edi,Bit_array_ptr
		cld
		xor al,al
	rep stosb							// Cleaning the bit array
 };
 Unsolvables_available=false;
 //of_pq.write(Bit_array_ptr,Bit_array_size); ?????
 for (unsigned int pp=0; pp<rrr; pp++ )
 {
  for (unsigned int qq=0; qq<rrr; qq++ )
  {
   nn=0;
   for (unsigned int tt=0; tt<rrr; tt++ )
   {
    if (Calculate_Q_pq_mod_prime(pp,qq,tt,rrr)==0)
    {
	 nn++;
	 break;
    };
   }; //end for tt
   if (nn==0)  // unsolvable found
   {
    Unsolvables_available=true;
    Bit_address=rrr*pp+qq;
    __asm{
        mov eax,Bit_address
        xor edx,edx
        div Const_8
        mov Byte_offset,eax
		mov ecx,edx //remainder in edx
        mov al,1
        or cl,cl
		jz m_004
		m_003:
		shl al,1
		loop m_003 // bit mask in al
		m_004:
        mov edi,Bit_array_ptr
        add edi,Byte_offset
        or [edi],al // write bit mask to Bit_array
    };
   };  //end if (nn==0)
  };   //end for qq
 };    //end for pp
 if (Unsolvables_available)
 {
  of_pq.write(Bit_array_ptr,Bit_array_size); //write to out file pq
  delete[] Bit_array_ptr;
  return(Bit_array_size);
 };
 delete[] Bit_array_ptr;
 return(0);
}
unsigned int __stdcall Test_Writing(unsigned int p, unsigned int q)
{
 p_global=p;
 q_global=q;

 of_report.open("Cuboid_search_report.txt",ios::out | ios::ate | ios::app);

 Search_is_running=true;
 _beginthread(Look_for_cuboids_thread,0,(void*)12);
 return(0);
}

